package ml.active;

import weka.active.*;
import weka.core.DataContainer;
import weka.core.Instances;

import ml.util.config.ReadOnlyConfiguration;


/**
 * <p>Title: Active Learning</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public abstract class XActiveLearner extends ActiveLearner {
    abstract public DataContainer create(Instances instances) throws Exception;

    /* This is a quick-and-dirty solution
    * the original imp. took the sacling info (min max values) from former
    * a better solution would perform a scalling on the whole original data
    * before splitting it to CV folds
    */
    abstract public DataContainer create(Instances data, DataContainer former) throws
            Exception;

    /**
     * initiate this XActiveLearner with the initialData
     *
     * @param initialData DataContainer should contain at least one
     * instance per class
     * @throws Exception
     */
    abstract public void init(DataContainer initialData) throws Exception;

    abstract public DataContainer create(String fileName) throws Exception;

    abstract public DataContainer create(double[][] attributes, double[] labels) throws
            Exception;

    abstract public void init(ReadOnlyConfiguration config) throws
            CreationException;

}
